#DEFINE WHITESPACE CHR(32)+CHR(0)+CHR(9)+CHR(10)+CHR(11)+CHR(12)+CHR(13)+CHR(26)

FUNCTION xVal
LPARAMETERS m.p1cString, p2return

    local m.lcTrimmed, m.temp, m.CurrSym, m.LenSym, ;
          m.i, m.j, m.k, m.l, m.n, ;
          m.SaveDecim, m.ThisDecim, m.E_or_D
    m.p2return = ""
    if VARTYPE(m.p1cString) == "C"
*       Eliminate leading and trailing 
*       white space, including CR, LF and CTRL+Z
        m.i = 0
        for m.j = 1 to LEN(m.p1cString)
            if .NOT.(SUBSTR(m.p1cString, ;
                     m.j, 1) $ WHITESPACE)
                m.i = m.j
                EXIT
            endif
        endfor
        if m.i = 0    && nothing in the string
            m.p1cString = 0
            return 0
        endif
        for m.j = LEN(m.p1cString) to m.i STEP -1
            if .NOT.(SUBSTR(m.p1cString, ;
                     m.j, 1) $ WHITESPACE)
                EXIT
            endif
        endfor
        m.lcTrimmed = SUBSTR(m.p1cString, ;
                      m.i, m.j - m.i + 1)
	else
        return m.p1cString
	endif

*   remove quotes
    do unBracket with m.lcTrimmed, '"', -1
    do unBracket with m.lcTrimmed, "'", -1
    m.lcTrimmed = UPPER( m.lcTrimmed )

* is it NULL
    if (m.lcTrimmed == "NULL") or ;
       (m.lcTrimmed == ".NULL.") or ;
       (m.lcTrimmed == ".N.")
        m.p1cString = 0
        m.p1cString = NULL
        return m.p1cString
    endif

*   "?", ".E." signify blank
    if (m.lcTrimmed == "BLANK") or ;
       (m.lcTrimmed == ".BLANK.") or ;
       (m.lcTrimmed == "?") or ;
       (m.lcTrimmed == ".E.")
        m.p1cString = 0
        return 0
    endif

*   is there a leading marker
    m.CurrSym = UPPER(ALLTRIM(SET("CURRENCY", 1)))
    m.LenSym = LEN(m.CurrSym)
    m.temp = 0
    DO CASE
    case LEFT(m.lcTrimmed, 1) == "%"
        m.temp = 1
        m.p2return = "%"
    
    case (m.LenSym > 0) and ;
         (UPPER(ALLTRIM(LEFT(m.lcTrimmed, ;
               m.LenSym))) == m.CurrSym)
        m.temp = m.LenSym
        m.p2return = "$"

    ENDCASE
    if m.temp > 0
        m.lcTrimmed = ALLTRIM(STUFF( ;
        m.lcTrimmed, 1, m.temp, ""))
	endif

*   parse, including E or D of 
*   scientific notation
    m.l = LEN( m.lcTrimmed )
    m.k = 0
    m.E_or_D = 0
    m.ThisDecim = 0
    for m.i = 1 to m.l
        m.temp = SUBSTR(m.lcTrimmed, m.i, 1)
        DO CASE
        case empty( m.ThisDecim ) and ;
            (m.temp == ".")
            m.ThisDecim = m.i

        case empty( m.k )
            if BETWEEN(m.temp, "0", "9")
                m.k = m.i
            endif

        case m.temp $ "EeDd"
            m.E_or_D = m.i
            EXIT

        case BETWEEN(m.temp, "0", "9")
            if empty( m.ThisDecim ) or ;
               not (m.temp == "0")
                m.k = m.i
            endif

        other
            EXIT

        ENDCASE
    endfor

*   determine digits after decimal
    m.SaveDecim = SET("DECIMAL")
    m.n = 0
    if (m.k > 0) and (m.E_or_D > m.k)
        for m.i = (m.E_or_D + 1) to m.l
            m.temp = SUBSTR(m.lcTrimmed, m.i, 1)
            DO CASE
            case m.temp $ "+-"
                if not empty( m.n )
                    EXIT
                endif

            case BETWEEN(m.temp, "0", "9")
                m.n = m.i

            other
                EXIT

            ENDCASE
		endfor
        if m.n > 0
            set decimal to 0
            m.E_or_D = VAL(SUBSTR( ;
                       m.lcTrimmed, m.E_or_D + 1))
        else
            m.E_or_D = 0
        endif
    else
        m.E_or_D = 0
    endif

*   is there a trailing % marker
    m.temp = IIF(m.n > m.k, m.n, m.k)
    if empty( m.p2return ) and (m.l > m.temp)
        m.temp = ALLTRIM(SUBSTR( ;
                 m.lcTrimmed, m.temp + 1))
        DO CASE
        case LEFT(m.temp, 1) == "%"
            m.p2return = "%"
        
        case (m.LenSym > 0) and ;
             (UPPER(ALLTRIM(LEFT(m.temp, ;
               m.LenSym))) == m.CurrSym)
            m.p2return = "$"

        ENDCASE
    endif

    if empty( m.k )
        if m.SaveDecim != m.ThisDecim
            set decimal to m.SaveDecim
        endif
        m.p1cString = 0
        return 0
    endif

*   adjust decimal digit for E or D power
    if (m.ThisDecim > 0) and (m.k > m.ThisDecim)
        m.ThisDecim = m.k - m.ThisDecim
    else
        m.ThisDecim = 0
    endif
    m.ThisDecim = m.ThisDecim - m.E_or_D
    DO CASE
    case m.ThisDecim < 0
    m.ThisDecim = 0

    case m.ThisDecim > 18
        m.ThisDecim = 18

    ENDCASE

*   call VAL intelligently
    set decimal to m.ThisDecim
    m.p1cString = VAL( m.lcTrimmed )
    if m.SaveDecim != m.ThisDecim
        set decimal to m.SaveDecim
    endif
return m.p1cString
#UNDEF   WHITESPACE

function unBracket
lparameters m.x, m.p2type, m.npairs

** p2type   can be e.g. "{"  or "<>" or even "-;"

** npairs = 0  && remove just one set
**        > 0  && upto this many sets
**        < 0  && all sets

	local m.L, m.loop, m.leftchar, m.rightchar, m.Result
	if VARTYPE(M.P2TYPE) == "C"
		m.leftchar = LEFT(m.p2type, 1)
		if LEN( m.p2type ) > 1
			m.rightchar = RIGHT(m.p2type, 1)
		else
			m.rightchar = ""
		endif
		DO CASE
		case empty( m.leftchar )
			m.leftchar = '('
			m.rightchar = ')'

		case empty( m.rightchar )
			DO CASE
			case m.leftchar == "("
				m.rightchar = ")"

			case m.leftchar == "["
				m.rightchar = "]"

			case m.leftchar == "{"
				m.rightchar = "}"

			case m.leftchar == "<"
				m.rightchar = ">"

			other
				m.rightchar = m.leftchar

			ENDCASE
		ENDCASE
	else
		m.leftchar = '('
		m.rightchar = ')'
	endif

	m.loop = 0
	m.Result = 0
	do while .T.
		m.x = ALLTRIM( m.x )
		if empty( m.x )
			return m.x
		endif
		m.l = len( m.x )
		if not empty( m.npairs ) and (m.npairs > 0)
			m.loop = m.loop + 1
			if m.loop > m.npairs
				EXIT
			endif
		endif
	    if (m.l > 1) and (left (m.x, 1) == m.leftchar) ;
	                 and (right(m.x, 1) == m.rightchar)
			m.l = m.l - 2
			m.x = SUBSTR(m.x, 2, m.L)
			m.Result = m.Result + 1
			if empty( m.npairs )
				EXIT
			endif
		else
	    	EXIT
	    endif
	enddo
	m.x = ALLTRIM( m.x )
	_TALLY = m.Result
return m.x
